{ Knihovna funkci pro manipulaci se stringy

  Autor:  Gord
  Verze 1.3.1
    - (2.10.2013)zmena typu parametru funkce Base64ToBitmap (kvuli prechodu na novy GG)
    - (15.12.2013) oprava DecToHex pro nektera zaporna ciska vypisuje 0000000
    - (15.12.2013) fova funkce FetchFight()

  ----------------
  Funkce verze:  1.0.0
    StringCompress(str:string):string;
      - vyhaze mezery, prevede na mala pismena, prvni znak slova vzdy velky
      - ekvivalent FilenameFromText z knihovny RelToAbsPath

    RemoveInvalidPathChars(str:string):string;
      - odstrani znaky, ktere mohou delat potize ve jmenech souboru

    IntToStrLength(iNum,len:integer):string;
      - vypis Int na zadany pocet znaku s levostrannymi nulami

    Base64ToBitmap(str:string):TBitMap;
      - vytvoreni bitove mapy z Base64 stringu (uvolnit bitmapu musi volajici)

  Funkce verze 1.1.0
    StrToStrings(str,separator:string):TStrings;
      - rozdeli string podle oddelovace 'separator' a prevede do TStrings

    StringsToStr(a:sTStrings; separator:string):string;
      - prevede TStrings na string oddeleny 'separatorem'

    GetCurrentPluginVersion:string;
      - vraci cislo verze pluginu nastavene v *.meta.ini souboru proave spusteneho
        pluginu

  Funkce verze 1.2.0
    function HexCharToInt(HexChar: String): Integer;
    function DecToHex(iNum,len:integer):string;
    function HexToDec(sHex: String): Integer;

  Funkce verze 1.3.0
    function AutoWrapText(text:string;len:integer):string;
}

//odstraneni znaku, ktere mohou delat potize ve jmenech souboru
function RemoveInvalidPathChars(str:string):string;
begin
  Result:=RegexReplace('[~^/|;,*?@&\"''<>=+{}]',str,'',false);
  //dvojtecka v ceste, pokud neni za pismenem disku, je chybna a mela by jit pryc
end;

//vyhaze mezery, prevede na mala pismena, prvni znak slova vzdy velky
function StringCompress(str:string):string;
var VelkePismenoZa:string;
    s:string;
    i,v:integer;
begin
  VelkePismenoZa:=' `~!?@%^&*+=:;,"<>''|/\';
  Result:='';
  v:=1;
  str:=LowerCase(str);
  for i:=1 to length(str) do
  begin
    s:=copy(str,i,1);
    if(pos(s,VelkePismenoZa)>0) then v:=1
    else begin
      if(v=1) then Result:=Result+UpperCase(s)
      else Result:=Result+s;
      v:=0;
    end;
  end;
  Result:=Result;
end;

//vypis Int na zadany pocet znaku s levostrannymi nulami
function IntToStrLength(iNum,len:integer):string;
begin
  Result:=IntToStr(iNum);
  if(length(Result)<len) then begin
    Result:=copy('0000000000000000000000000000000',1,len-length(Result))+Result;
  end;
end;

//vytvoreni bitove mapy z Base64 stringu (uvolnit bitmapu musi volajici)
function Base64ToBitmap(str:ansistring):TBitMap;
var s:ansistring;
    stream:TMemoryStream;
begin
  stream:=TMemoryStream.Create;
  try
    s:=DecodeBase64(str);
    stream.Write(s,Length(s));
    stream.Position:=0;
    Result:=TBitMap.Create();
    Result.LoadFromStream(stream);
  finally
    stream.free;
  end;
end;

function StrToStrings(str,separator:string):TStrings;
begin
  Result:=TStringList.Create();
  while (str<>'') do begin
    Result.Add(Fetch(str,separator));
  end;
end;

function StringsToStr(a:TStrings;separator:string):string;
var i:integer;
begin
  Result:='';
  for i:=0 to a.Count-1 do begin
    if(i>0) then Result:=Result+separator;
    Result:=Result+a[i];
  end;
end;

function GetCurrentPluginVersion:string;
begin
  Result:=GeoGetPackageVersion(ReplaceString(GEOGET_SCRIPTFULLNAME,'.ggp.pas','.meta.ini'));
end;

function HexCharToInt(HexChar: String): Integer;  {prevod jednoho Hex znaku na Int}
begin
  Result:=0;
  HexChar:=Uppercase(HexChar);
  if((HexChar>='0') and (HexChar<='9')) then Result:=Ord(HexChar[1])-48
  else if((HexChar>='A') and (HexChar<='Z')) then Result:=Ord(HexChar[1])-65+10;
end;

function HexToDec(sHex: String): Integer;   {prevod Hex na Dec}
var i:integer;
begin
  Result:=0;
  for i:=1 to Length(sHex) do begin
    Result:=Result+(HexCharToInt(copy(sHex,i,1))*Trunc(Power(16,Length(sHex)-i)));
  end;
end;

function DecToHex(iNum,len:integer):string;
var iByte:byte;
    s:string;
begin
  s:='0123456789ABCDEF';
  Result:='';
  while(iNum<>0) do begin
    iByte:=iNum and $0f;
    iNum:=iNum shr 4;
    Result:=s[iByte+1]+Result;
  end;
  if(length(Result)<len) then Result:=copy('00000000',1,len-length(Result))+Result
  else if(length(Result)>len) then Result:=copy(Result,1,len);
end;

function AutoWrapText(text:string;len:integer):string;
var reg:string;
begin
  //zalomi text na bilem znaku nejblize k zadane delce
  reg:='(.{0,'+IntToStr(len)+'}[^\s]*)\s?';
  Result:=RegexReplace(reg,trim(text),'$1'+CRLF,true);
  //Result:=RegexReplace(CRLF+'$',Result,'',true);
end;
